'     - Strongly Typed Collection  ColumnPrintItem 
Imports System.ComponentModel

<AttributeUsage(AttributeTargets.All), DefaultProperty("item")> _
Public Class ColumnsPrinting
    Inherits System.Collections.CollectionBase

    '---------  PROPERTIES-----------------
    ' item  ColumnPrintItem    index      index
    Default Public Shadows Property item(ByVal index%) As ColumnPrintItem
        Get
            If index >= 0 Then Return Me.List.Item(index) Else Return Nothing
        End Get
        Set(ByVal Value As ColumnPrintItem)
            If index >= 0 Then Me.List.Item(index) = Value
        End Set
    End Property
    '---------------------------------------------------------
    ' item  ColumnPrintItem    ColumnName      pos
    Default Public Shadows Property item(ByVal NameCol$) As ColumnPrintItem
        Get
            Dim pos = Me.Find(NameCol)
            If pos >= 0 Then Return Me.item(pos) Else Return Nothing
        End Get
        Set(ByVal Value As ColumnPrintItem)
            Dim pos = Me.Find(NameCol)
            If pos >= 0 Then Me.item(pos) = Value
        End Set
    End Property
    '---------------------------------------------------------
    '------------------------
    '-------------------------------
    '------------------------------
    '   ,  ArrayList,     
    Public Function Find%(ByVal NameCol$)

        Dim i% = 0, breqike As Boolean = False
        Dim Colitem As New ColumnPrintItem()
        Try
            '    .
            While (i <= Count - 1) And (Not breqike)
                Colitem = Me.item(i)
                If Colitem.ColumnName = NameCol Then
                    breqike = True
                Else
                    i += 1
                End If
            End While
        Catch
            i = -1
        End Try
        Colitem = Nothing
        If breqike Then Return i Else Return -1

    End Function
    '-------------------------------
    '     
    Public Function Add(ByVal newColItem As ColumnPrintItem) As Boolean

        Try
            Me.List.Add(newColItem)
            Return True
        Catch
            Return False
        End Try

    End Function
    '-------------------------------
    '       position.
    Public Function Add(ByVal Position%, ByVal newColItem As ColumnPrintItem) As Boolean

        Try
            Me.List.Insert(Position, newColItem)
            Return True
        Catch
            Return False
        End Try

    End Function
    '-------------------------------
    '   .
    Public Function Remove(ByVal ColItem As ColumnPrintItem) As Boolean

        Try
            Me.List.Remove(ColItem)
            Return True
        Catch
            Return False
        End Try

    End Function
    '-------------------------------

End Class
