Imports System.Drawing

'  .
Public Class FormatPrint

    '     (,   ) 
    Public Enum ContentFormatTypeEnum
        NoDefined = 0
        IsNumberFormat
        IsDateFormat
        IsBooleanFormat
    End Enum

    '      boolean   
    Public Enum BooleanTranslateEnum
        Check = 0
        ߼
        YesNo
        
        
        TrueFalse
    End Enum

    Public Font As Font                                 '
    Public ForeColor As Color                           '
    Public Alignment As clsPrinting.AlignmentEnum       '.
    Public ContentFormatType As ContentFormatTypeEnum   '  (/  ) 
    Public ContentFormat$                               'To format  .. "dd/mm/yyyy"  "Short Date"  "###.###"  
    Public BooleanTranslateFormat As BooleanTranslateEnum  '   boolean   
    '--------------------------------------------------------------------------------
    'Overloaded constructor - minimal version
    Public Sub New()

        Font = New Font("Arial", 10, FontStyle.Regular, PrintUnitCurrent)
        ForeColor = Color.Black
        Alignment = clsPrinting.AlignmentEnum.Left
        ContentFormatType = ContentFormatTypeEnum.NoDefined
        ContentFormat = "" : BooleanTranslateFormat = BooleanTranslateEnum.߼
    End Sub
    '--------------------------------------------------------------------------------
    'Full version constructor
    Public Sub New(ByVal whatFont As Font, ByVal whatColor As Color, ByVal whatAlignment As clsPrinting.AlignmentEnum, ByVal whatContentFormatType As ContentFormatTypeEnum, ByVal whatContentFormat$, ByVal BoolTranslateFormat As BooleanTranslateEnum)

        With whatFont
            Font = New Font(.FontFamily, .Size, .Style, PrintUnitCurrent)
        End With
        ForeColor = whatColor
        Alignment = whatAlignment
        ContentFormatType = whatContentFormatType
        ContentFormat = whatContentFormat
        BooleanTranslateFormat = BoolTranslateFormat

    End Sub
    '--------------------------------------------------------------------------------
    'Overloaded version constructor
    Public Sub New(ByVal whatFont As Font, ByVal whatColor As Color, ByVal whatAlignment As clsPrinting.AlignmentEnum, ByVal whatContentFormatType As ContentFormatTypeEnum, ByVal whatContentFormat$)

        With whatFont
            Font = New Font(.FontFamily, .Size, .Style, PrintUnitCurrent)
        End With
        ForeColor = whatColor
        Alignment = whatAlignment
        ContentFormatType = whatContentFormatType
        ContentFormat = whatContentFormat
        BooleanTranslateFormat = BooleanTranslateEnum.߼

    End Sub
    '--------------------------------------------------------------------------------
    'Overloaded constructor
    Public Sub New(ByVal whatFont As Font, ByVal whatColor As Color, ByVal whatAlignment As clsPrinting.AlignmentEnum)

        With whatFont
            Font = New Font(.FontFamily, .Size, .Style, PrintUnitCurrent)
        End With
        ForeColor = whatColor
        Alignment = whatAlignment
        '  - nodefined
        ContentFormatType = ContentFormatTypeEnum.NoDefined
        ContentFormat = ""
        BooleanTranslateFormat = BooleanTranslateEnum.߼

    End Sub
    '--------------------------------------------------------------------------------
    'Overloaded constructor 
    Public Sub New(ByVal newFormatPrint As FormatPrint)

        With newFormatPrint
            Font = New Font(.Font.FontFamily, .Font.Size, .Font.Style, .Font.Unit)
            ForeColor = .ForeColor
            Alignment = .Alignment
            ContentFormatType = .ContentFormatType
            ContentFormat = .ContentFormat
            BooleanTranslateFormat = newFormatPrint.BooleanTranslateFormat
        End With
    End Sub
    '--------------------------------------------------------------------------------
    '   Boolean     boolean       
    Public Function GetBooleanString$(ByVal fldBoolValue As Boolean, ByVal whatBoolFormat As BooleanTranslateEnum)

        Select Case whatBoolFormat
            Case Is = BooleanTranslateEnum.߼ : Return IIf(fldBoolValue, "", "")
            Case Is = BooleanTranslateEnum.YesNo : Return IIf(fldBoolValue, "Yes", "No")
            Case Is = BooleanTranslateEnum. : Return IIf(fldBoolValue, "", "")
            Case Is = BooleanTranslateEnum.TrueFalse : Return IIf(fldBoolValue, "True", "False")
            Case Is = BooleanTranslateEnum. : Return IIf(fldBoolValue, "", " ")
            Case Is = BooleanTranslateEnum.Check : Return IIf(fldBoolValue, "", "")
        End Select

    End Function
    '--------------------------------------------------------------------------------
End Class
